Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5213)
@@ -1433,56 +1735,62 @@
 
       CALL var_add_value( var__init_dp, dd_value(:,:,:,:), &
-      &                   id_start(:), id_count(:) )
+      &                   il_type, id_start(:), id_count(:) )
+
+      ! clean
+      CALL dim_clean(tl_dim)
 
    END FUNCTION var__init_dp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(4) 1D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(4) 1D array of value.
    !> @details 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
    !> dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('z') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('z') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] rd_value : 1D table of real(4) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] rd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] rd_value        1D array of real(4) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] rd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_1D_sp( cd_name, rd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, rd_fill, cd_units,&
+   &                                    td_att, rd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -1503,4 +1811,5 @@
       REAL(sp)        ,                       INTENT(IN), OPTIONAL :: rd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -1550,4 +1859,5 @@
       &                         dd_fill=dl_fill,                    &
       &                         cd_units=cd_units,                  &
+      &                         cd_axis=cd_axis,                    &
       &                         cd_stdname=cd_stdname,              &
       &                         cd_longname=cd_longname,            &
@@ -1565,53 +1875,56 @@
  
    END FUNCTION var__init_1D_sp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(4) 2D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(4) 2D array of value.
    !> @details 
-   !> table of 2 dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y') and we 
-   !> use table size as lentgh dimension. 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
+   !> array of 2 dimension structure is needed to put value in variable structure. 
+   !> If none is given, we assume array is ordered as ('x','y') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] rd_value : 2D table of real(4) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] rd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         : variable name
+   !> @param[in] rd_value        : 2D array of real(4) value
+   !> @param[in] id_start        : index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        : number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         : variable type 
+   !> @param[in] td_dim          : array of dimension structure
+   !> @param[in] td_att          : array of attribute structure
+   !> @param[in] rd_fill         : fill value
+   !> @param[in] cd_units        : units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      : variable standard name
+   !> @param[in] cd_longname     : variable long name
+   !> @param[in] cd_point        : point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           : variable id
+   !> @param[in] id_ew           : east west wrap
+   !> @param[in] dd_scf          : scale factor
+   !> @param[in] dd_ofs          : add offset
+   !> @param[in] id_rec          : record id (for rstdimg file)
+   !> @param[in] dd_min          : minimum value
+   !> @param[in] dd_max          : maximum value
+   !> @param[in] ld_contiguous   : use contiguous storage or not 
+   !> @param[in] ld_shuffle      :  shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   : fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       : deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      : chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_2D_sp( cd_name, rd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, rd_fill, cd_units,&
+   &                                    td_att, rd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -1625,6 +1938,6 @@
       CHARACTER(LEN=*),                       INTENT(IN) :: cd_name
       REAL(sp)        , DIMENSION(:,:)     ,  INTENT(IN) :: rd_value
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_start
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_count
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_start
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_count
       INTEGER(i4)     ,                       INTENT(IN), OPTIONAL :: id_type 
       TYPE(TDIM)      , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: td_dim
@@ -1632,4 +1945,5 @@
       REAL(sp)        ,                       INTENT(IN), OPTIONAL :: rd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -1681,4 +1995,5 @@
       &                         dd_fill=dl_fill,                    &
       &                         cd_units=cd_units,                  &
+      &                         cd_axis=cd_axis,                    &
       &                         cd_stdname=cd_stdname,              &
       &                         cd_longname=cd_longname,            &
@@ -1696,53 +2011,56 @@
       
    END FUNCTION var__init_2D_sp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(4) 2D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(4) 3D array of value.
    !> @details 
-   !> table of 2 dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y') and we 
-   !> use table size as lentgh dimension. 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
+   !> array of 3 dimension structure is needed to put value in variable structure. 
+   !> If none is given, we assume array is ordered as ('x','y','z') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] rd_value : 2D table of real(4) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] rd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         : variable name
+   !> @param[in] rd_value        : 2D array of real(4) value
+   !> @param[in] id_start        : index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        : number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         : variable type 
+   !> @param[in] td_dim          : array of dimension structure
+   !> @param[in] td_att          : array of attribute structure
+   !> @param[in] rd_fill         : fill value
+   !> @param[in] cd_units        : units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      : variable standard name
+   !> @param[in] cd_longname     : variable long name
+   !> @param[in] cd_point        : point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           : variable id
+   !> @param[in] id_ew           : east west wrap
+   !> @param[in] dd_scf          : scale factor
+   !> @param[in] dd_ofs          : add offset
+   !> @param[in] id_rec          : record id (for rstdimg file)
+   !> @param[in] dd_min          : minimum value
+   !> @param[in] dd_max          : maximum value
+   !> @param[in] ld_contiguous   : use contiguous storage or not 
+   !> @param[in] ld_shuffle      :  shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   : fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       : deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      : chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_3D_sp( cd_name, rd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, rd_fill, cd_units,&
+   &                                    td_att, rd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -1756,6 +2074,6 @@
       CHARACTER(LEN=*),                       INTENT(IN) :: cd_name
       REAL(sp)        , DIMENSION(:,:,:)   ,  INTENT(IN) :: rd_value
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_start
-      INTEGER(i4)     , DIMENSION(:)       , INTENT(IN), OPTIONAL :: id_count
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_start
+      INTEGER(i4)     , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: id_count
       INTEGER(i4)     ,                       INTENT(IN), OPTIONAL :: id_type 
       TYPE(TDIM)      , DIMENSION(:)       ,  INTENT(IN), OPTIONAL :: td_dim
@@ -1763,4 +2081,5 @@
       REAL(sp)        ,                       INTENT(IN), OPTIONAL :: rd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -1813,4 +2132,5 @@
       &                         dd_fill=dl_fill,                    &
       &                         cd_units=cd_units,                  &
+      &                         cd_axis=cd_axis,                    &
       &                         cd_stdname=cd_stdname,              &
       &                         cd_longname=cd_longname,            &
@@ -1828,53 +2148,56 @@
       
    END FUNCTION var__init_3D_sp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(4) 4D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(4) 4D array of value.
    !> @details 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
    !> Dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y','z','t') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('x','y','z','t') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] rd_value : 4D table of real(4) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] rd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] rd_value        4D array of real(4) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] rd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle      shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_sp( cd_name, rd_value,        &
    &                                 id_start, id_count, id_type, td_dim, &
-   &                                 td_att, rd_fill, cd_units,&
+   &                                 td_att, rd_fill, cd_units, cd_axis,&
    &                                 cd_stdname, cd_longname,  &
    &                                 cd_point, id_id, id_ew,   &
@@ -1895,4 +2218,5 @@
       REAL(sp)        ,                       INTENT(IN), OPTIONAL :: rd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -1946,4 +2270,5 @@
       &                      dd_fill=dl_fill,                    &
       &                      cd_units=cd_units,                  &
+      &                      cd_axis=cd_axis,                    &
       &                      cd_stdname=cd_stdname,              &
       &                      cd_longname=cd_longname,            &
@@ -1961,53 +2286,56 @@
       
    END FUNCTION var__init_sp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - integer(8) 1D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a integer(8) 1D array of value.
    !> @details 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
    !> dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('z') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('z') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] kd_value : 1D table of integer(8) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] kd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         : variable name
+   !> @param[in] kd_value        : 1D array of integer(8) value
+   !> @param[in] id_start        : index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        : number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         : variable type 
+   !> @param[in] td_dim          : array of dimension structure
+   !> @param[in] td_att          : array of attribute structure
+   !> @param[in] kd_fill         : fill value
+   !> @param[in] cd_units        : units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      : variable standard name
+   !> @param[in] cd_longname     : variable long name
+   !> @param[in] cd_point        : point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           : variable id
+   !> @param[in] id_ew           : east west wrap
+   !> @param[in] dd_scf          : scale factor
+   !> @param[in] dd_ofs          : add offset
+   !> @param[in] id_rec          : record id (for rstdimg file)
+   !> @param[in] dd_min          : minimum value
+   !> @param[in] dd_max          : maximum value
+   !> @param[in] ld_contiguous   : use contiguous storage or not 
+   !> @param[in] ld_shuffle      :  shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   : fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       : deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      : chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_1D_i8( cd_name, kd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, kd_fill, cd_units,&
+   &                                    td_att, kd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -2028,4 +2356,5 @@
       INTEGER(i8)     ,                       INTENT(IN), OPTIONAL :: kd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -2075,4 +2404,5 @@
       &                         dd_fill=dl_fill,                    &
       &                         cd_units=cd_units,                  &
+      &                         cd_axis=cd_axis,                    &
       &                         cd_stdname=cd_stdname,              &
       &                         cd_longname=cd_longname,            &
